
NAME="pfm"
PLATFORM="caanoo wiz"
BUILD=$(cat ./BUILD)
SRCPATH=$(realpath source)
PLATFORMPATH=$(realpath platform)
DISTPATH=$(realpath .dist)
SRCFILES="*.pyc plugins modes core"

WD="$(pwd)"
cd "$SRCPATH"
if python -m compileall .; then
    echo "Reompiled!"
else
    echo "Bad release!"
    exit 1
fi

for P in $PLATFORM; do
    cd "$SRCPATH"
    BUILDNAME="$NAME-$BUILD-$P"
    BUILDDIR="$DISTPATH/$BUILDNAME"
    echo D= "$BUILDDIR"
    echo N= "$BUILDNAME"
    rm -r "$BUILDDIR"
    mkdir -p "$BUILDDIR"
    rm -r "$BUILDDIR"/*
    echo "Copy contents..."
    cp -r $SRCFILES --target-directory="$BUILDDIR"/
    echo "Copy static..."
    cp -r "$PLATFORMPATH"/all/* --target-directory="$BUILDDIR"/
    cp -r "$PLATFORMPATH"/$P/*  --target-directory="$BUILDDIR"/
    echo "version = \"$BUILDNAME\"" >> "$BUILDDIR"/conf/pfm.conf
    echo "Packing..."
    cd "$DISTPATH"
    find "$BUILDDIR" -name "*.py" -delete
    find "$BUILDDIR" -name "*~" -delete
    rm "$BUILDNAME"-*.tar.gz
    tar -czf "$BUILDNAME".tar.gz "$BUILDNAME"
    MD5=$(md5sum "$BUILDNAME".tar.gz | cut -f 1 -d " ")
    mv "$BUILDNAME".tar.gz "$BUILDNAME"-["$MD5"].tar.gz
done

cd "$WD"
