
import pygame
import os

##from pfm import ModLoad

conf_dir = '/tmp'
__cf = {}
__state = {}

def p(key, val=None):
	global __cf
	if not val==None:
		__cf[key] = val
	return __cf[key]

### deprecated
def state(key, val=None):
	global __state
	if not val==None:
		__state[key] = val
	return __state[key]

### deprecated
def load_states():
	global __state, __cf, conf_dir
	__state = grow_from_config( __state,  __cf['statefile']  )

### deprecated
def save_states():
	global __state, __cf, conf_dir
	save_to_config( __state,  __cf['statefile']  )

def grow_from_config( dict, filename,  callback=None):
	print filename
	try:
		fp = open( filename,  "rt" )
	except IOError:
		return dict

	sp = " \n\r\t"
	for line in fp.readlines():
		line = line.decode('utf-8').strip( sp )
		if len(line):
			if line[0] == '#': continue
			try:
				(param, value) = line.split( "=", 2 )
				param = param.strip( sp )
				value = value.strip( sp )
			except ValueError:
				continue

			# config contains quoted strings, color tuples or integers
			#
			if len(value) and value[0] == u'"':
				value = value.strip('"')
			elif len(value) and value[0] == u'(':
				value = rgbval(value)
			else:
				value = int(value)
			if callback:
				callback(param, value)
			dict[param] = value
	fp.close()
	return dict

def save_to_config( dict, filename ):
	try:
		fp = open( filename ,  "wt" )
	except IOError:
		return False

	e = 'utf-8'
	for (k,v) in dict.iteritems():
		if type(v) == type(u'') or type(v) == type(''):
			v = '"' + v + '"'
		elif type(v) == type( () ):
			v = valrgb(v)
		else:
			v = str(v)
		fp.write( k.encode(e) + " = " + v.encode(e) + "\n" )

	fp.close()
	return True

def load( dirname='./conf/', userdir='./user/' ):
	""" Load base config """
	global __cf, conf_dir
	##Log.msg( 'Reading configs: '+dirname )

	conf_dir = os.path.abspath( dirname )
	userdir  = os.path.abspath( userdir )

	if not os.path.exists(userdir) :
		os.makedirs(userdir)

	__cf = {
			'width'		 	: 320,
			'height'		: 240,
			'fullscreen' 	: 0,
			'textcolor'		: (200,200,0),
			'textcolor-h0'	: (200,100,50),
			'textcolor-h1'	: (100,250,100),
			'textcolor-h2'	: (250,200,200),
			'textcolor-er'	: (250,0,0),
			'linecolor'		: (50,250,50),
			'padding'		: 2,
			'fontsize'		: 23,
			'statefile'		: os.path.join( userdir, 'pfm.state' ),
			'wifipskfile'	: os.path.join( userdir, 'wifipsk.state' ),
			'tmpdir'		: os.path.join( '/tmp/' ),
			'comp_padding'	: 0,
			'version'		: 'rawrun',
			'update_url'	: 'http://localhost/updates/pfm/',
			'net_prefer_wifi': True,
			'_confdir'		: dirname,
			'_userdir'		: userdir,
			}

	__cf = grow_from_config( __cf, os.path.join( conf_dir,'pfm.conf' ) )
	__cf = grow_from_config( __cf, os.path.join( userdir, 'pfm.conf' ) )

	if __cf.has_key('fontface'):
		__cf['_font']	= pygame.font.Font( os.path.join( conf_dir, __cf['fontface']), __cf['fontsize'] )
	else:
		__cf['_font']	= pygame.font.SysFont( pygame.font.get_default_font(), __cf['fontsize'] )

	#__cf['_BGM']   = pygame.Surface.convert(pygame.image.load( conf_dir+'/'+'bg8.png' ))
	try:
		if __cf.has_key('background'):
			__cf['_BGM']   = pygame.image.load( os.path.join( conf_dir, __cf['background'] ) )
	except:
		pass
	if not __cf.has_key('_BGM'):
		__cf['_BGM']   = pygame.Surface( (__cf['width'],__cf['height']) )

	# base lineheight
	__cf['_lineheight'] = (__cf['_font'].render( 'H', True, __cf['textcolor'] )).get_height()
	__cf['_lineheight'] += __cf['padding'] * 2

	__cf['_subsysdir']	= os.path.abspath ( os.path.join( conf_dir , '../subsys') )


def save(self):
	global __cf, conf_dir
	#fp = open( os.path.abspath ( conf_dir+'/pfm.conf' ),  "wt" );
	#fp.close();

def rgbval( txt ):
	if type( txt ) == type( '' ) or type( txt ) == type( u'' ):
		return tuple( map( lambda x: int(x), txt.strip( u'()' ).split( u',' ) ) )
	else:
		return txt

def valrgb( rgb ):
		return u"(" + u",".join( map( lambda x: str(x), rgb ) ) + u")"
