import os, stat
#import Config, Log, ImageMaster
from pfm import ModLoad
Config		= ModLoad("core", "Config")

Menu		= ModLoad("core", "Menu")
Log         = ModLoad("core", "Log")
Plugins     = ModLoad("core", "Plugins")

# ----------------------------------------------------------------- #

def DetectorFactory(entry):
	return Plugins.getFileTypePlugins( entry )

# ----------------------------------------------------------------- #

class PfmDirectoryNavigator:
	""" Directory navigation"""
	def __init__( self, initialdir=u"/" ):
		self.chdir( initialdir )
		self.name = False

	def chdir(self, initialdir = u"/"):
		initialdir = unicode(initialdir)
		Log.msg( "CHDIR "+initialdir )
		self.list = None
		self.dir  = os.path.abspath(initialdir).replace('//','/')
		self.name = os.path.basename( self.dir )+'/'

	def get_list( self ):
		def t(s=self):
			s._get_list()
		Menu.Wait( t, "list" )
		return self._get_list()

	def _get_list( self ):
		if self.list == None :
			self.list = []
			try:
				for fn in os.listdir( self.dir ):
					fp = os.path.abspath( self.dir + '/' + fn )
					try:
						st = os.stat(fp)
						if stat.S_ISDIR( st.st_mode ): fn = fn + '/'
						ent = {
							'type'		: 'dirent',
							'ftype'		: 'dir' if stat.S_ISDIR( st.st_mode ) else 'file',
							'fext'		: os.path.splitext(fp)[1],
							'text'		: unicode(fn),
							'fullpath'	: unicode(fp),
							'size'		: st.st_size,
							'ctime'		: st.st_ctime,
							'mtime'		: st.st_mtime,
							'mime'		: '?',
							'known'		: False,
							'plugins'	: [],
						}
						ent['plugins'] = DetectorFactory( ent )
						ent['known'] = reduce( lambda x, y: x or hasattr(y, 'open'), ent['plugins'], False )
						self.list.append ( ent )
					except Exception, e:
						self.list.append ( {
							'type'		: 'dirent',
							'ftype'		: 'error',
							'text'		: unicode(fn),
							'fullpath'	: fp,
							'size'		: st.st_size,
							'ctime'		: st.st_ctime,
							'mtime'		: st.st_mtime,
							'mime'		: '?',
							'known'		: False,
							'plugins'	: [],
						})
			except Exception, e:
				Log.msg( "locked dir" )
				Log.msg( e )
			self.sort();
		return self.list

	def sort( self ):
		def ev( a, b):
			if a['ftype']!='dir' and b['ftype']=='dir': return  1
			if a['ftype']=='dir' and b['ftype']!='dir': return -1

			if a['text'] >  b['text']: return 1
			if a['text'] == b['text']: return 0
			return -1

		self.list.sort( ev )


