
import pygame

from pfm import ModLoad

Config     = ModLoad("core", "Config")
EntryTypes = ModLoad("core", "EntryTypes")
##Log  = ModLoad("core", "Log")

class PfmEntryList:
	"""Visualised entry list"""
	def __init__(self, ents, initial = False):
		self.relist(ents, initial )
		self.y_sh = 0 # current blanket shift
		self.feedheight= Config.p('_lineheight')
		self.x = 0
		self.y = 0
		self.pagesize = 10

	def get_maxwidth(self):
		if self.maxw == 0:
			for i in range(0,len(self.list)):
				s = self.get_entry_surface(i)
				if self.maxw <= s.get_width():
					self.maxw = s.get_width()
		return self.maxw

	def set_xy(self, x, y):
		self.x = x
		self.y = y

	def relist(self, ents, parent = False):
		self.maxw = 0
		self.list = ents
		if parent == False:
			self.pos = 0
		else:
			self.pos = 0
			for i in range(0,len(self.list)):
				if self.list[i]['text'] == parent :
					self.pos = i
					break
		self.visuals = {}

	def next(self):
		self.pos+=1
		if( self.pos > len(self.list)-1 ): self.pos = 0

	def prev(self):
		self.pos-=1
		if( self.pos<0 ): self.pos = len(self.list) - 1

	def next_page(self):
		self.pos += self.pagesize
		if( self.pos > len(self.list)-1 ): self.pos = len(self.list)-1

	def prev_page(self):
		self.pos -= self.pagesize
		if( self.pos<0 ): self.pos = 0

	def sh(self, hh):
		""" Compute new eye-candy vertical shift """
		y_pos = ( self.pos * self.feedheight )
		self.y_sh = y_pos - hh/2  # hh - screen height
		print 't.ysh=',self.y_sh
		if self.y_sh<0: self.y_sh=0

	def item(self):
		try:
			return self.list[self.pos]
		except IndexError:
			return None

	def get_entry_surface(self, pos, hl=False):
		k = (pos,hl)
		if( self.visuals.has_key(k) ) :
			return self.visuals[k]
		self.visuals[k] = t = EntryTypes.Entry_render( self.list[pos], None, hl )
		return t

	def render(self, surf):
##		ww = surf.get_width()
##		hh = surf.get_height()
		
		hh = len(self.list) * self.feedheight
		if hh> surf.get_height(): 
			hh=surf.get_height()		
			self.sh(hh)
		else:
			self.y_sh=0
			
		self.pagesize = hh /  self.feedheight
		
		print self.x, self.y
		print 'pos, ysh =', self.pos,',',self.y_sh
		for i in range(0,len(self.list)):
			y = i * self.feedheight
			if y - self.y_sh + self.feedheight < 0 : continue
			if y - self.y_sh > hh : return
			su = self.get_entry_surface( i , i==self.pos)
			surf.blit( su, ( self.x, self.y+y - self.y_sh, su.get_width(), su.get_height()) )

