
import pygame

from pfm import ModLoad

Config	= ModLoad("core", "Config")
Log		= ModLoad("core", "Log")

def Entry_render( entry, surface=None, outline=False ):
	pname = entry['type'].capitalize()+'_render'
	Log.msg( pname )
	try:
		p = globals()[pname]
	except KeyError:
		p = Text_render
	res = p( entry, surface )

	if outline and res:
		pygame.draw.rect(res, Config.p('linecolor'), ( 0, 0, res.get_width(), res.get_height()-1 ), 1)

	return res

def astext_render( text, color = None ):
	if color == None :
		color = Config.p('textcolor')
	Log.msg( 'Text: ', text )
	fnt = Config.p('_font')
	pad = Config.p('padding')
	txt = fnt.render( text, True, color )
	txt.set_colorkey( (0,0,0,0) )
	tmp = pygame.Surface( ( txt.get_width() + pad*2, txt.get_height() + pad*2 ), pygame.SRCALPHA)
	#tmp.fill( (0,0,0,0) )
	tmp.blit(txt,( pad, pad, txt.get_width(), txt.get_height()) )
	return tmp

def Text_render( entry, surface=None ):
	# Every entry MUST have 'text' value
	txt = astext_render( entry['text'] )
	if surface :
		surface.blit( tmp )
		return None
	else :
		return txt

def Dirent_render( entry, surface=None ):
	color = None
	if entry['ftype'] == 'dir':
		color = Config.p('textcolor-h0')
	elif entry['ftype'] == 'error':
		color = Config.p('textcolor-er')
	elif entry['known']:
		color = Config.p('textcolor-h1')
##	elif

	txt = astext_render( entry['text'], color )
	if surface :
		surface.blit( tmp )
		return None
	else :
		return txt

def Wifinet_render( entry, surface=None ):
	color = None

	label = 'NET: '+entry['essid']+' - '

	if entry['enc']:
		label += 'enc, '
		label += entry['enctype']+'+'+entry['cip']+'+'+entry['auth']+' '
		if entry['enctype'] in ( 'WPA2', 'WPA' ) and entry['auth'] in ('PSK'):
			label += 'O'
		else:
			label += 'X'
	else:
		label += 'O'

	txt = astext_render( label , color )
	if surface :
		surface.blit( tmp )
		return None
	else :
		return txt

def Gopher_render( entry, surface=None ):
	color = None
	if entry['gtype'] == '1':
		color = Config.p('textcolor-h0')
	elif entry['gtype'] in ['0','1','4','5','6','9','g','I','p','s',]:
		color = Config.p('textcolor-h1')
	elif entry['gtype'] != 'i':
		color = Config.p('textcolor-er')
##	elif

	txt = astext_render( entry['text'], color )
	if surface :
		surface.blit( tmp )
		return None
	else :
		return txt
