
import pygame, os
import exif, imageinfo

from pfm import ModLoad
CacheMaster     = ModLoad("core", "CacheMaster")


def is_known_type(file_path):
	ext = os.path.splitext(file_path)[1]
	return ext.lower() in [
		'.jpg','.jpeg','.png','.gif','.bmp','.pcx',
		'.tga','.tif','.tiff','.lbm','.xpm']

def get_preview( file_path, size ):
	pw = CacheMaster.short_get( ('preview', (size), file_path) )
	if pw == None:
		t = CacheMaster.short_get( ('image', file_path) )
		if t == None:
			t = pygame.image.load( file_path ).convert()
			CacheMaster.short_save( ('image', file_path), t )

		t = t.convert(24)
		width  = size[0]
		height = size[1]
		pw = pygame.Surface( (width, height), flags=t.get_flags(), depth=t.get_bitsize(), masks=t.get_masks() )
		pygame.transform.smoothscale( t, (width, height), pw )

		CacheMaster.short_save( ('preview', (size), file_path), pw )

	return pw

def get_imagesize( file_path ):
	tags = exif.parse( file_path , 0, mode=exif.ASCII )
	ow = oh = False
	try:
		if tags.has_key('ExifImageWidth') and tags.has_key('ExifImageHeight'):
			ow = int( tags['ExifImageWidth'] )
			oh = int( tags['ExifImageHeight'] )
		else:
			t = CacheMaster.short_get( ('image', file_path) )
			if t == None:
				t = pygame.image.load( file_path ).convert()
				CacheMaster.short_save( ('image', file_path), t )
			ow = t.get_width()
			oh = t.get_height()
	except ValueError:
		pass

	return (ow, oh)
