import pygame
import Log

PC = {
}

Wiz = {
}

Caanoo = {
	'RIGHT'	: 'JOY_0_AXIS_0_PLUS',
	'LEFT'	: 'JOY_0_AXIS_0_MINUS',
	'DOWN'	: 'JOY_0_AXIS_1_PLUS',
	'UP'	: 'JOY_0_AXIS_1_MINUS',
	'CENTER': 'JOY_0_BTN_10',
	'A'		: 'JOY_0_BTN_0',
	'B'		: 'JOY_0_BTN_2',
	'X'		: 'JOY_0_BTN_1',
	'Y'		: 'JOY_0_BTN_3',
	'HOME'	: 'JOY_0_BTN_6',
	'HELP1'	: 'JOY_0_BTN_8',
	'HELP2'	: 'JOY_0_BTN_9',
	'L'		: 'JOY_0_BTN_4',
	'R'		: 'JOY_0_BTN_5',
	'LOCK'	: 'JOY_0_BTN_7',
}


class Spooler:
	def __init__(self):
		self.i = 0;
		self.reinit_freq = 100
		self.jask_freq = 200
		self.jthres = 0.3
		self.jstate = set()

		self.__j_reinit()

	def __j_reinit(self):
		self.j_cnt = pygame.joystick.get_count();
		self.j = [];
		for i in range(0,self.j_cnt):
			self.j.append( pygame.joystick.Joystick(i) )
		for i in range(0,self.j_cnt):
			Log.msg( "J Found:" + self.j[i].get_name() )
			if not self.j[i].get_init():
				self.j[i].init()

	def __j_get_state(self, joy):
		res = []
		pr = 'JOY_'+str(joy.get_id())+'_'

		for i in range(0, joy.get_numbuttons() ):
			if joy.get_button(i):
				res.append( pr+'BTN_'+str(i) )

		for i in range(0, joy.get_numaxes() ):
			v = joy.get_axis(i)
##			print pr+'AXIS_'+str(i), 'V=', v, '/', self.jthres
			if v > +self.jthres:
				res.append( pr+'AXIS_'+str(i)+'_PLUS' )
			if v < -self.jthres:
				res.append( pr+'AXIS_'+str(i)+'_MINUS' )
		return res


	def spool(self):
		res = []
		js  = set()
		for j in self.j :
			js |= set(self.__j_get_state(j))

		prss = js - self.jstate
		for i in prss:
			res.append(i)
		#rls  = self.jstate - js

		self.jstate = js


		kpref= "KB_"
		for event in pygame.event.get() :
			if( event.type == pygame.QUIT ) :
				res.append('QUIT')
			if( event.type == pygame.KEYUP ) :
				res.append( kpref+pygame.key.name(event.key).upper()+'_DOWN' )
			if( event.type == pygame.KEYDOWN ) :
				res.append( kpref+pygame.key.name(event.key).upper()+'_UP' )
##		print res
		return res


class Bindings:
	""" action to key bindings """
	def __init__(self):
		self._binds = {} # a -> [k,k,k...]
		self._sdnib = {} # k -> [a,a,a...]
		self._alias = {}

	def set_alias(self, a):
		self._alias = a

	def bind(self, action, key):
		if self._alias.has_key(key):
			key = self._alias[key]
##		print action, 'bind', key

		if not self._binds.has_key(action):
			self._binds[action] = []
		if not key in self._binds[action]:
			self._binds[action].append(key)

		if not self._sdnib.has_key(key):
			self._sdnib[key] = []
		if not action in self._sdnib[key]:
			self._sdnib[key].append(action)

	def key2action( self, key ):
		# has bind?
		if not self._sdnib.has_key(key):
			return None

		if len(self._sdnib[key])==1:
			return self._sdnib[key][0]

	def is_act( self, key, action ):
		# has bind?
		if not self._sdnib.has_key(key):
			return False

		if action in self._sdnib[key]:
			return True

		return False

	def b(self):
		return  self._sdnib

