
import pygame
import Config, EntryTypes

class Window:
	def __init__( self, p ):
		self.text = u"some text"
		self.append = u''
		self.set_visualdata(p)

	def set_visualdata(self, p):
		self.p = p
		# cursor position
		self.pos = len(self.text)
		self.c4 = [0,0,0,0]
		for i in (0,1,2,3):
			l = len(p['chars'][i]) / 2
			self.c4[i] = ( p['chars'][i][0:l], p['chars'][i][l:] )
		self.headpane = False
		self.footpane = False

	def panes_prerender(self,surface):
		ww = surface.get_width()
		hh = surface.get_height()

		l = []
		for i in self.p['layouts']:
			t = EntryTypes.astext_render( i )
			if i == self.p['lactive']:
				pygame.draw.rect( t, Config.p('linecolor'),( 0,0, t.get_width(), t.get_height() ), 1 )
			l.append( t )

		k = []
		for i in self.p['maps']:
			t = EntryTypes.astext_render( i )
			if i == self.p['mactive']:
				pygame.draw.rect( t, Config.p('linecolor'),( 0,0, t.get_width(), t.get_height() ), 1 )
			k.append( t )

		c = [
			EntryTypes.astext_render( self.c4[0][0] ),
			EntryTypes.astext_render( self.c4[0][1] ),
			EntryTypes.astext_render( self.c4[1][0] ),
			EntryTypes.astext_render( self.c4[1][1] ),
			EntryTypes.astext_render( self.c4[2][0] ),
			EntryTypes.astext_render( self.c4[2][1] ),
			EntryTypes.astext_render( self.c4[3][0] ),
			EntryTypes.astext_render( self.c4[3][1] ),
		]

		mw = 10

		for i in c:
			if mw < i.get_width():
				mw = i.get_width()

		lh = c[0].get_height()

		footh = lh * 6
		headh = hh - footh
		print ww, hh, headh, footh

##		padw = mw / 3
##		padh = mw / 4

		LC  = Config.p('linecolor')
		TC  = Config.p('textcolor')

		headrect  = ( 0, 0, ww, headh )
		footrect = ( 0, headh, ww, footh )

		self.headpane = pygame.Surface( ( ww, headh ), pygame.SRCALPHA )
		self.footpane = pygame.Surface( ( ww, footh ), pygame.SRCALPHA )

		#layouts & maps
		yy = footh - lh -1
		for i in l:
			self.footpane.blit( i, ( 0, yy, i.get_width(),  i.get_height() ) )
			yy -= lh

		yy = footh - lh -1
		for i in k:
			self.footpane.blit( i, ( ww-i.get_width(), yy, i.get_width(),  i.get_height() ) )
			yy -= lh

		# 4chars panel
		xx = (ww - mw)/2
		self.footpane.blit( c[0], ( xx, 1,    mw, lh ) )
		self.footpane.blit( c[1], ( xx, 1+lh, mw, lh ) )
		pygame.draw.rect(self.footpane, LC, ( xx, 1, mw, lh*2 ), 1 )

		self.footpane.blit( c[2], ( xx-mw/2, 1+lh*2, mw, lh ) )
		self.footpane.blit( c[3], ( xx-mw/2, 1+lh*3, mw, lh ) )
		pygame.draw.rect(self.footpane, LC, ( xx-mw/2, 1+lh*2, mw, lh*2 ), 1 )

		self.footpane.blit( c[4], ( xx+mw/2, 1+lh*2, mw, lh ) )
		self.footpane.blit( c[5], ( xx+mw/2, 1+lh*3, mw, lh ) )
		pygame.draw.rect(self.footpane, LC, ( xx+mw/2, 1+lh*2, mw, lh*2 ), 1 )

		self.footpane.blit( c[6], ( xx, 1+lh*4, mw, lh ) )
		self.footpane.blit( c[7], ( xx, 1+lh*5, mw, lh ) )
		pygame.draw.rect(self.footpane, LC, ( xx, 1+lh*4, mw, lh*2 ), 1 )


		#display outlines
		pygame.draw.rect(self.headpane, LC, ( 0, 0, ww, headh ), 1 )
		pygame.draw.rect(self.footpane, LC, ( 0, 0, ww, footh ), 1 )

	def set_cursor(self, pos):
		self.pos = pos

	def set_text(self, text):
		self.text = unicode(text)

	def set_append(self, append):
		self.append = unicode(append)

	def fixate_append(self):
		print 'fixate_append: ',self.append
		self.text += self.append
		self.append = u''

	def backspace(self):
		if len(self.append):
			self.append = u''
		else :
			self.text = self.text[:-1]

	def render(self, surface):
		ww = surface.get_width()
		hh = surface.get_height()

		if self.headpane == False or self.footpane == False :
			self.panes_prerender(surface)

		surface.blit( self.headpane, self.headpane.get_rect() )
		surface.blit( self.footpane, ( 0,self.headpane.get_height() ,ww, self.footpane.get_height() ) )

		x = 10
		y = 10

		# line of text
		line = EntryTypes.astext_render(self.text)
		surface.blit( line, ( x, y, line.get_width(), line.get_height() ) )
		cur = EntryTypes.astext_render(self.append)
		pygame.draw.rect(cur, Config.p('linecolor'), (0,0, cur.get_width(), cur.get_height()), 1)
		surface.blit( cur, ( x+line.get_width(), y, cur.get_width(), cur.get_height() ) )
		#pygame.draw.rect(surface, LC, ( x, y, mw, lh ), 1 )


