
import os
from pfm import ModLoad
Log		= ModLoad("core", "Log")

#
# layouts/layout1/Keymap1
# layouts/layout1/Keymap2
# layouts/layout2/Keymap1
#
#

class Layouts:
	"""Layouts/keymaps interface"""
	def __init__( self, from_dir ):
		self.layouts = {}
		self.selected = False
		for fn in os.listdir( from_dir ):
			#try:
			l = Layout4Side( os.path.realpath(from_dir+'/'+fn) )
			self.layouts[l.name] = l
			if not self.selected:
				self.selected = l.name
			#except:
			#	continue

		if len( self.layouts )==0:
			raise Exception, "No valid keymaps/layouts!"

		Log.msg(  "layouts = " + str(len( self.layouts ) ) )
		Log.msg( self.layouts.keys() )

	def active_layout(self):
		return  self.layouts[self.selected]

	def next_layout(self):
		ln = self.layouts.keys();
		f = False
		for i in ln:
			if f:
				self.selected = i
				return
			if i==self.selected:
				f = True
		self.selected = ln[0]

	def next_map(self):
		self.active_layout().next_map()

	def get_visual(self):
		lnames = self.layouts.keys()
		lsel   = self.active_layout().name
		lmaps  = self.active_layout().get_map_names()
		lmap   = self.active_layout().active_map().name
		lchars = self.active_layout().active_map().chars4()
		lchar  = self.active_layout().active_map().active_char()
		return {
		'layouts'	: lnames,
		'lactive'	: lsel,
		'maps'		: lmaps,
		'mactive'	: lmap,
		'chars'		: lchars,
		'cactive'	: lchar,
				}

	def getchar( self, keynum ):
		return self.active_layout().active_map().getchar(keynum)

	def reset( self ):
		return self.active_layout().active_map().reset()

class Layout4Side:
	def __init__( self, dirname ):
		self.name = os.path.basename( dirname ).decode('utf-8')
		Log.msg( "Load Layout:"+dirname )
		self.maps = []
		self.map_names = []
		self.selected  = 0;
		for fn in os.listdir( dirname ):
			try:
				k = Keymap4Side( dirname + '/' + fn )
				self.maps.append( k )
				self.map_names.append(k.name)
			except None, e:
				raise e
				continue

		if not len( self.maps):
			raise Exception, "Empty layout: " + dirname

	def get_map_names(self):
		return self.map_names

	def next_map(self):
		self.selected +=1
		if self.selected >= len(self.maps):
			self.selected = 0

	def active_map(self):
		return self.maps[self.selected]


class Keymap4Side:
	"""4-buttons input keymap"""
	def __init__( self, filename ):
		Log.msg( "Loading keymap:" + filename )
		#self.name = os.path.basename( filename )
		self.pads = []
		e = 'UTF-8'
		f = open(filename, "rt");
		self.name = f.readline().decode(e).strip()
		self.pads.append( f.readline().decode(e).strip() )
		self.pads.append( f.readline().decode(e).strip() )
		self.pads.append( f.readline().decode(e).strip() )
		self.pads.append( f.readline().decode(e).strip() )
		f.close()

		self.reset()

	def reset(self):
		self.selected = -1
		self.pos = 0

	def getchar( self, keynum ):
		if(keynum != self.selected):
			self.selected = keynum
			self.pos = 0

		if self.pos >= len(self.pads[self.selected]):
			self.pos = 0
		elif self.pos < 0:
			self.pos = len(self.pads[self.selected]) - 1

		self.pos += 1
		return self.pads[self.selected][self.pos-1]

	def chars4(self):
		return self.pads

	def active_char(self):
		return self.pads[self.selected]


