
#import SysOps, ModeTextEd, Informer
import urllib, os

from pfm import ModLoad
SysOps	= ModLoad("core", "SysOps")
Informer= ModLoad("core", "Informer")
Config  = ModLoad("core", "Config")

Mode	= ModLoad("modes", "Mode")
##
## iwpriv wlan0 auth 4
## (1 - OPEN, 2 - SHARED , 3 - WPAPSK, 4 - WPA2PSK, 5 - WPANONE)
## iwpriv wlan0 enc 4
## (1 - none, 2 - WEP, 3 - TKIP, 4 - AES)
## iwpriv wlan0 wpapsk "my_WPA_PSK_key"

# iwpriv wlan0 set NetworkType=Infra
# iwpriv wlan0 set Channel=10
# iwpriv wlan0 set AuthMode=WPA2PSK
# iwpriv wlan0 set EncrypType=AES
# iwpriv wlan0 set SSID="mySSID"
# iwpriv wlan0 set WPAPSK="my_WPA_PSK_key"
# iwpriv wlan0 set SSID="mySSID"

def is_net_available(test_net=True, test_internat=False):
	r = filter( lambda x: x[0]!='lo' and x[1]!=None, ifconfig() )
	print r
	return len(r)>0

def ifconfig(a = True):
	if a :
		ic = SysOps.quick_exec('/sbin/ifconfig -a', True)
	else:
		ic = SysOps.quick_exec('/sbin/ifconfig', True)
	res = []
	dev = None
	adr = None
	for line in ic:
		if line=="\n":
			res.append( (dev,adr) )
			dev = None
			adr = None
			continue
		if line[0].isspace():
			t = line.strip()
			if t[:10] == 'inet addr:':
				adr = t[10:].split(" ")[0]
		else:
			dev = line.split(" ")[0]
	return res

def gph_try_network():
	SysOps.async_exec('insmod $(find /lib -iname \'usbcore.ko\')',   'usbcore.ko', True)
	SysOps.async_exec('insmod $(find /lib -iname \'hcd9032.ko\')',   'hcd9032.ko',True)
	SysOps.async_exec('insmod $(find /lib -iname \'rt3070sta.ko\')', 'rt3070sta.ko',True)
	SysOps.async_exec('insmod $(find /lib -iname \'af_packet.ko\')', 'af_packet.ko',True)
##	if self._dev != False:
##			SysOps.quick_exec('ifconfig '+self._dev+' down', True)


def wifi_list_networks(dev):
	SysOps.async_exec('ifconfig '+dev+' up', dev+' up', True)

	iwlist = '$(find /lib -name iwlist)'
##	iwlist = 'iwlist'

	res = []
	data = SysOps.async_exec(iwlist+' '+dev+' scan', 'Scanning...', True )
	c ={
		'type'		:'wifinet',
		'text'		:'NETWORK',
		'essid'		:False,
		'enc'		:'?',
		'mac'		:'?',
		'enctype'	:'?',
		'auth'		:'?',
		'cip'		:'?',
	}
	cellinfo = dict(c)
	firstf = True
	for net in data:
		net = net.strip()
		#print net
		sp = map( lambda x: x.strip(), net.split(':',1) );
		print sp
		if len(sp)==2:
			if 'WPA Version 1' in sp[1]:
				cellinfo['enctype'] = 'WPA'
				continue

			if 'IEEE 802.11i/WPA2' in sp[1]:
				cellinfo['enctype'] = 'WPA2'
				continue

			if 'Encryption key' in sp[0]:
				cellinfo['enc'] = (sp[1] == 'on')
				continue

			if 'Group Cipher' in sp[0]:
				cellinfo['cip'] = sp[1]
				if sp[1]=='CCMP':
					cellinfo['cip'] = 'AES'
				continue

			if 'Authentication Suites' in sp[0]:
				cellinfo['auth'] = sp[1]
				continue

			if 'ESSID' in sp[0]:
				cellinfo['essid'] = sp[1].strip('"')
				continue

			if 'Address' in sp[0]:
				if not firstf:
					print 'push'
					res.append(cellinfo)
					cellinfo = dict(c)
				cellinfo['mac'] = sp[1]
				firstf = False
				continue

	if cellinfo['essid'] != False : res.append(cellinfo)

	print 'res=',res
	return res

def net_down( dev ):
	SysOps.async_exec('ifconfig '+dev+' down', '...', True)

def wifi_connect( dev, entry ):
	## entry = net Entry
	SysOps.async_exec('ifconfig '+dev+' down', '...', True)
	SysOps.async_exec('ifconfig '+dev+' up', 'if '+dev+' up', True)

	if entry['enc'] :
		if not ( entry['enctype'] in ( 'WPA2', 'WPA' ) and entry['auth'] in ('PSK') ):
			Log.msg("Warn: UNKNOWN ENC MODE ",entry['enctype'] ,' ',entry['auth'])

	conf = '$(find /lib -name iwconfig) '+dev+' '
	priv = '$(find /lib -name iwpriv) '+dev+' '
	if entry['enc'] :
		load_state()
		if entry['enctype'] in ('WPA', 'WPA2'):
			if entry['auth'] == 'PSK':
				Informer.set_text('Passkey for '+entry['essid'])
				if 	wifi_connect._known_nets.has_key(entry['mac']):
					psk = wifi_connect._known_nets[entry['mac']]
				else:
					psk = ''

				psk = Mode.ModalMode('ModeTextEd', psk )

				if psk==None :
					return

				wifi_connect._known_nets[entry['mac']]	= psk

				SysOps.async_exec( priv + 'set NetworkType=Infra','Infra',True)
				if entry['enctype']=='WPA':
					SysOps.async_exec( priv + 'set AuthMode=WPAPSK','WPAPSK',True)
				else:
					SysOps.async_exec( priv + 'set AuthMode=WPA2PSK','WPA2PSK',True)

				if entry['cip'] == 'AES':
					SysOps.async_exec( priv + 'set EncrypType=AES','AES',True)
				elif entry['cip'] == 'TKIP':
					SysOps.async_exec( priv + 'set EncrypType=TKIP','TKIP',True)

				SysOps.async_exec( priv + 'set SSID='   + SysOps.shellarg(entry['essid']),'ESSID',True)
				SysOps.async_exec( priv + 'set WPAPSK=' + SysOps.shellarg(psk),'PSK',True)
				SysOps.async_exec( priv + 'set SSID='   + SysOps.shellarg(entry['essid']),'ESSID',True)
				# iwpriv wlan0 set NetworkType=Infra
				# iwpriv wlan0 set Channel=10
				# iwpriv wlan0 set AuthMode=WPA2PSK
				# iwpriv wlan0 set EncrypType=AES
				# iwpriv wlan0 set SSID="mySSID"
				# iwpriv wlan0 set WPAPSK="my_WPA_PSK_key"
				# iwpriv wlan0 set SSID="mySSID"
				SysOps.async_exec('/sbin/udhcpc -n -i '+dev+' -q', 'DHCP...',True)
		save_state()
	else:
		SysOps.async_exec( conf + 'essid ' + SysOps.shellarg(entry['essid']), 'ESSID', True)
		SysOps.async_exec( conf + 'mode managed', 'managed', True)
		SysOps.async_exec( '/sbin/udhcpc -n -i '+dev+' -q', 'DHCP...',True)
##	SysOps.async_exec('$(find /lib -name iwconfig) '+dev+' key ', True)

wifi_connect._known_nets ={}

def wifi_auto_connect( dev ):
	#
	# scan wifi, choose known/open network and join
	#
	pass

def net_list_hosts( dev ):
	#
	#
	#
	pass

def state_file_name():
	return os.path.join( Config.p('_userdir'), 'Net.known_wifi' )

def load_state():
	wifi_connect._known_nets = Config.grow_from_config( {}, state_file_name())

def save_state():
	Config.save_to_config( wifi_connect._known_nets, state_file_name() )
