
import pygame

from pfm import ModLoad
Config		= ModLoad("core", "Config")
EntryTypes	= ModLoad("core", "EntryTypes")

class PfmEntryStack:
	"""Entry list"""
	def __init__(self):
		self.stack = []
		self.visuals = {}

	def push(self, entry):
		self.visuals = {}
		self.stack.append(entry)

	def pop(self):
		self.visuals = {}
		if not len(self.stack): return None
		return self.stack.pop()

	def top(self):
		if not len(self.stack): return None
		return self.stack[-1]

	def roll(self, dir=+1):
		if not len(self.stack): return

		self.visuals = {}
		if(dir>0):
			self.stack.insert(0, self.stack.pop() )
		else:
			t = self.stack[0];
			self.stack = self.stack[1:]
			self.stack.append(t)

	def get_entry_surface(self, pos, hl=False):
		k = (pos, hl)
		if( self.visuals.has_key(k) ) :
			return self.visuals[k]
		self.visuals[k] = t = EntryTypes.Entry_render( self.stack[pos], None, hl )
		return t

	def render(self, surf):
		#empty stack
		if not len( self.stack ): return

		ww = surf.get_width()
		hh = surf.get_height()
		cnt = len(self.stack);
		maxhh = hh/2

		top  = self.get_entry_surface ( cnt-1, True )
		lh   = topw = top.get_height();
		toph = top.get_width();
		top = pygame.transform.rotate(top, 90)

		maxww = 3 * topw;

		# visible lines = total lines minus one (more button)
		vlines = maxhh / topw
		# nline - "x12 more..."
		nline = 0
		if vlines < cnt:
			if vlines+1 == len(self.stack):
				vlines += 1
			else:
				nline = 1

		#maxh = (vlines + nline) * topw

		x = ww - maxww
		y = hh - maxhh

		tbuf = pygame.Surface( (maxww,maxhh), pygame.SRCALPHA )

		y_int = 0

		if nline:
			xs = EntryTypes.astext_render( 'x ' + str(len( self.stack )) );
			tbuf.blit( xs, ( 0, maxhh - topw, maxww , maxhh) )

		r = range( cnt - vlines, cnt - 1)
		r.reverse()
		for i in r:
			if i<0 : continue
			t = self.get_entry_surface( i )
			tbuf.blit( t, ( 0, y_int, maxww, maxhh ) )
			y_int += topw

		tbuf.fill( (0,0,0), ( maxww-topw, maxhh-toph, topw, toph)  )
		surf.blit( tbuf, (x,y, maxww, maxhh) )
		surf.blit( top, ( ww-topw, hh-toph, topw, toph) )
