import pygame
#import Config, InputAbst, Menu, CacheMaster, ImageMaster, Lazy

from pfm import ModLoad
Config		= ModLoad("core", "Config")
CacheMaster	= ModLoad("core", "CacheMaster")
ImageMaster	= ModLoad("core", "ImageMaster")
Menu		= ModLoad("core", "Menu")
Lazy		= ModLoad("core", "Lazy")
Log			= ModLoad("core", "Log")

Mode =  ModLoad("modes", "Mode")
ModeName = "Image Viewer"

class ModeThread (Mode.ModeAbstract):
	"""File manager mode"""
	def __init__(self):
		self.map = None
		super(ModeThread,self).__init__()

	def _modalparams(self, *params):
		self._entry = params[0]

	def render(self):
		Log.msg("View redraw")
		if not self.map:
			Log.msg("bad map in ImageViewer")
			return
			
		surf = self._layer.start()
		surf.blit( self.map,
			(
			(self._layer.get_width() - self.map.get_width() )/2,
			(self._layer.get_height() - self.map.get_height() )/2
			)
		)
		self._layer.stop()

	def load(self):
		t = CacheMaster.short_get( ('image', self._entry['fullpath'].encode('utf-8')) )
		if t == None:
			try:
				t = pygame.image.load( self._entry['fullpath'].encode('utf-8') ).convert()
				CacheMaster.short_save( ('image', self._entry['fullpath'].encode('utf-8')), t )
			except:
				return

		t = t.convert(24)
		width  = t.get_width()
		height = t.get_height()
		if  width > self._layer.get_width():
			width  = self._layer.get_width()
			height = t.get_height() * width / t.get_width()
		if height > self._layer.get_height():
			height = self._layer.get_height()
			width  = t.get_width() * height / t.get_height()

		self.map = pygame.Surface( (width, height), flags=t.get_flags(), depth=t.get_bitsize(), masks=t.get_masks() )
		pygame.transform.smoothscale(t, (width, height), self.map)

	def loop(self):
		binds = Config.p('_keybindings')

		Menu.Wait(self.load, "Loading...")

		self.render()
		self._layer.set_visible(True)

		while not self.isTerminated():
			Mode.Clock.tick(30)
			for event in self._im.spool( ) :
				if  binds.is_act( event, 'MODE_KEY_SYSMENU' ):
					self.show_mode_menu()
					self.render()
					continue

				if  binds.is_act( event, 'DOWN' ):
					return 'DOWN'

				if  binds.is_act( event, 'UP' ):
					return 'UP'

				if  binds.is_act( event, 'KEY_OK' ):
					return

