import pygame

from pfm import ModLoad

EntryList =  ModLoad("core", "EntryList")
Informer  =  ModLoad("core", "Informer")

Mode =  ModLoad("modes", "Mode")
ModeName = "Key Tester"

class ModeThread (Mode.ModeAbstract):
	"""Key mapping discover"""
	def __init__(self):
		self._list  = []
		self._menu  = EntryList.PfmEntryList( self._list )
		super(ModeThread,self).__init__()

	def render(self):
		surf = self._layer.start()
		self._menu.render(surf)
		self._layer.stop()

	def loop(self):
		lastev = ""
		max = 100
		cnt = max
		self.render()
		while not self.isTerminated():
			Mode.Clock.tick(30)
			cnt -= 1
			Informer.set_text( str(cnt) )
			if cnt<=0:
				self.show_mode_menu()
				cnt = max

			for event in self._im.spool( ) :
				if event=='QUIT':
					self.show_mode_menu()
					cnt = max

				if event!=lastev:
					cnt = max
					self._list.insert(0, {'type':'text', 'text':event} )
					self._menu.relist(self._list)
					self.render()
				lastev = event


