#
# Pythoned File Manager
#
#  Eugene Popov aka EugeneP, 2012
#    mailto:popov_e_n@mail.ru
#    http://uwolke.ru
#    http://wiz.rusbase.net
#
import pygame
#import Config, EntryList, InputAbst, Informer
#from Net import *

from pfm import ModLoad
Config		= ModLoad("core", "Config")
EntryList	= ModLoad("core", "EntryList")
Menu		= ModLoad("core", "Menu")
Net			= ModLoad("core", "Net")
Informer	= ModLoad("core", "Informer")
Log			= ModLoad("core", "Log")

Mode =  ModLoad("modes", "Mode")
ModeName = 'Nerworking'


class ModeThread (Mode.ModeAbstract):
	"""General networking settings"""
	def __init__(self):
		self._list = []
		self._menu = EntryList.PfmEntryList( self._list )
		# Found networks
		self._w_networks = []
		# Found neighbours
		self._w_hosts = []
		self.update_info()
##		Net.wifi_connect._known_nets = Config.grow_from_config( {}, Config.p('wifipskfile'))
		super(ModeThread,self).__init__()

	def update_menu(self):
		self._list = [
				{ 'type': 'menu', 'text':'Retry networking','val':'refresh'}
		]

		if self._dev != None:
			self._list.append(
				{ 'type': 'menu', 'text':'Scan WiFi','val':'wifi-scan'}
			)
			self._list.append(
				{ 'type': 'menu', 'text':'Turn off net','val':'net-off'},
			)

		if self._adr != None:
			self._list.append(
				{ 'type': 'menu', 'text':'Scan /24 subnet','val':'net-scan'}
			)

		for net in self._w_networks:
			self._list.append(net)

		for host in self._w_hosts:
			self._list.append(
				{ 'type': 'menu', 'text':'HOST: '+host,'val':'host-connect', 'name':host}
			)

		self._menu.relist(self._list)

	def update_info(self):
		self._adr = None
		self._dev = None
		r = Net.ifconfig()

		for dev in r:
			if dev[0] == 'lo':
				continue
			self._dev = dev[0]
			if dev[1] != None:
				self._adr = dev[1]
				break

		self.update_menu()

	def render(self):
		Log.msg("Net redraw")
		if self._adr ==  None:
			a = 'No'
		else:
			a = self._adr
		if self._dev ==  None:
			d = 'No'
		else:
			d = self._dev
		Informer.set_text(a+' / '+d)
		surf = self._layer.start()
		self._menu.render(surf)
		self._layer.stop()

	def loop(self):
		binds = Config.p('_keybindings')
		self.render()
		while not self.isTerminated():
			Mode.Clock.tick(30)
			for event in self._im.spool( ) :
				if  binds.is_act( event, 'MODE_KEY_SYSMENU' ):
					self.show_mode_menu()
					self.render()
					continue

				if binds.is_act( event, 'UP' ):
					self._menu.prev()
					self.render()

				if binds.is_act( event, 'DOWN' ):
					self._menu.next()
					self.render()

				if binds.is_act( event, 'LEFT' ):
					self._menu.prev_page()
					self.render()

				if binds.is_act( event, 'RIGHT' ):
					self._menu.next_page()
					self.render()

				if binds.is_act( event, 'KEY_OK' ):
					item = self._menu.item()
					if not item:
						continue

					if item['type'] == 'wifinet' and self._dev!=None:
						Net.wifi_connect(self._dev, item)
##						Config.save_to_config( Net.wifi_connect._known_nets, Config.p('wifipskfile') )
						self.update_info()
						self.render()
						continue

					if item['val']=='exit':
						continue

					if item['val']=='net-off':
						Net.net_down(self._dev)
						self.update_info()
						self.render()

					if item['val']=='refresh':
						Net.gph_try_network()
						self.update_info()
						self.render()

					if item['val']=='wifi-scan':
						self._w_networks = Net.wifi_list_networks(self._dev)
						self.update_info()
						self.render()



