
import pygame
#import Config, Informer, InputAbst, InputWindow, Menu
from pfm import ModLoad

Config		= ModLoad("core", "Config")
InputWindow	= ModLoad("core", "InputWindow")
Menu		= ModLoad("core", "Menu")
#SysOps		= ModLoad("core", "SysOps")
#EntryList	= ModLoad("core", "EntryList")
#DirectoryNavigator	= ModLoad("core", "DirectoryNavigator")
#InputAbst	= ModLoad("core", "InputAbst")

Mode =  ModLoad("modes", "Mode")
ModeName = "Text Editor"

class ModeThread (Mode.ModeAbstract):
	"""File manager mode"""
	def __init__(self):
		self.Lman	= Config.p('_Lmanager')
		self.Lman.selected = 'Lat'
		self.text	= ''

		super(ModeThread,self).__init__()

	def _modalparams(self, *params):
		self.text = params[0]

	def render(self):
		print "TextEd redraw"
		surf = self._layer.start()
		self.iw.render(surf)
		self._layer.stop()

	def loop(self):
		binds = Config.p('_keybindings')
		iw = self.iw = InputWindow.Window( self.Lman.get_visual() )
		iw.set_text( self.text )

		thres   = 20
		ticks   = 0
		lastpad = -1
		pad     = -1

		self.render()

		while not self.isTerminated():
			Mode.Clock.tick(50)
			if  lastpad >=0 and ticks<=0:
				#fixate letter
				iw.fixate_append()
				pad = lastpad = -1
				self.Lman.reset()
				self.render()

			lastpad = pad
			if ticks>0: ticks -= 1

			for event in self._im.spool( ) :
				if  binds.is_act( event, 'MODE_KEY_SYSMENU' ):
					self.show_mode_menu()
					self.render()
					continue

				if binds.is_act( event, 'MODE_KEY_MODEMENU' ):
					ch = Menu.Dialog(
						'Apply changes?',
						(
							{ 'type':'menu', 'text':'Apply & exit', 'val':True },
							{ 'type':'menu', 'text':'Edit more', 'val':False },
						)
						)
					if(ch['val']):
						self.text = iw.text
						return self.text
					self.render()
					continue

				if binds.is_act( event, 'UP' ):
					pad = 0
					ticks  = thres
					if  pad!=lastpad :
						#fixate letter
						iw.fixate_append()
					iw.set_append( self.Lman.getchar(0) )
					self.render()
					continue

				if binds.is_act( event, 'LEFT' ):
					pad = 1
					ticks  = thres
					if  pad!=lastpad :
						#fixate letter
						iw.fixate_append()
					iw.set_append( self.Lman.getchar(1) )
					self.render()
					continue

				if binds.is_act( event, 'RIGHT' ):
					pad = 2
					ticks  = thres
					if  pad!=lastpad :
						#fixate letter
						iw.fixate_append()
					iw.set_append( self.Lman.getchar(2) )
					self.render()
					continue

				if binds.is_act( event, 'DOWN' ):
					pad = 3
					ticks  = thres
					if  pad!=lastpad :
						#fixate letter
						iw.fixate_append()
					iw.set_append( self.Lman.getchar(3) )
					self.render()
					continue

				if binds.is_act( event, 'TX_KEY2' ):
					ticks  = thres
					iw.backspace()
					self.Lman.reset()
					self.render()
					continue

				if binds.is_act( event, 'TX_KEY1' ):
					ticks  = thres
					iw.set_append(' ')
					iw.fixate_append()
					self.Lman.reset()
					self.render()
					continue

				if binds.is_act( event, 'TX_LAYOUT' ):
					self.Lman.next_layout()
					iw.set_visualdata( self.Lman.get_visual() )
					self.render()
					continue

				if binds.is_act( event, 'TX_VARIANT' ):
					self.Lman.next_map()
					iw.set_visualdata( self.Lman.get_visual() )
					self.render()
					continue

