import pygame
#import Config, InputAbst, Menu, CacheMaster, ImageMaster, Lazy

from pfm import ModLoad
Config		= ModLoad("core", "Config")
Menu		= ModLoad("core", "Menu")
Log			= ModLoad("core", "Log")
TextView	= ModLoad("core", "TextView")

Mode		= ModLoad("modes", "Mode")

ModeName = "Text Viewer"

class ModeThread (Mode.ModeAbstract):
	"""File manager mode"""
	def __init__(self):
		self.map = None
		self.textfile = None
		super(ModeThread,self).__init__()

	def _modalparams(self, *params):
		self._entry = params[0]

	def render(self):
		surf = self._layer.start()
		self.textfile.render(surf)
		self._layer.stop()

	def load(self):
		self.textfile = TextView.PfmTextFile( open(self._entry['fullpath'],"rt"),0 )

	def loop(self):
		binds = Config.p('_keybindings')

		Menu.Wait(self.load, "Loading...")

		self.render()
		self._layer.set_visible(True)

		while not self.isTerminated():
			Mode.Clock.tick(30)
			for event in self._im.spool( ) :
				if  binds.is_act( event, 'MODE_KEY_SYSMENU' ):
					self.show_mode_menu()
					self.render()
					continue

				if binds.is_act( event, 'UP' ):
					self.textfile.prev()
					self.render()

				if binds.is_act( event, 'DOWN' ):
					self.textfile.next()
					self.render()
