#!/usr/bin/python

#
# Pythoned File Manager
#
#  Eugene Popov aka EugeneP, 2012
#    mailto:popov_e_n@mail.ru
#    http://uwolke.ru
#    http://wiz.rusbase.net
#
import pygame
import sys, os

import imp

try:
	import threading as _threading
except ImportError:
	import dummy_threading as _threading

#import Config, Compositor, Menu, Informer, InputAbst
#import ModeFM, ModeTextEd, Menu, Log, VersionUpdate
#import ModeKeytest



# ----------------------------------------------------------------- #
class PfmMain:
	"""The Main PyMan Class - This class handles the main initialization and creating of the Game."""
	def __init__(self):
		pygame.init()
		Config.load()

		## postload {{{
		Config.p('_Lmanager', Keymaps.Layouts( os.path.join( Config.conf_dir , 'keymaps') ) )

		#bindings
		b = InputAbst.Bindings()
		balias = Config.grow_from_config( {}, os.path.join ( Config.conf_dir,'alias.conf' ) )
		b.set_alias(balias)

		binds = []
		bcb = lambda key, value: binds. append( (key,value) )
		Config.grow_from_config( {}, os.path.join ( Config.conf_dir,'bind.conf' ), bcb )

		for (action,keyev) in binds:
			b.bind(action, keyev)

		Config.p('_keybindings', b)
		Config.p('_im', InputAbst.Spooler() )
		##Log.msg( Config.__cf )

		## }}} postload
		flg = 0
		if Config.p('fullscreen') : flg ^= pygame.FULLSCREEN
		self.screen = pygame.display.set_mode(  ( Config.p('width'), Config.p('height') ),  flg, 16 )
		pygame.mouse.set_visible( False )

		Config.state("navigator_dir", u"./")
		Config.state("navigator_file", u"")
		Config.load_states()

		rect = (
				Config.p('comp_padding'),
				Config.p('comp_padding'),
				Config.p('width')  - Config.p('comp_padding')*2,
				Config.p('height') - Config.p('comp_padding')*2,
				)
		self.comp = Compositor.Compositor(self.screen)
		# dialog windows
		self.comp.new_layer('dialog', rect[0], rect[1], rect[2], rect[3] )
		# hints & quickinfo
		self.comp.new_layer('hints', rect[0], rect[1], rect[2], rect[3] )
		# statusbar
		self.comp.new_layer('status', rect[0], rect[1], rect[2], Config.p('_lineheight'))
		# main workspace
		self.comp.new_layer('screen', rect[0], rect[1]+Config.p('_lineheight')-1,
									rect[2], rect[3]-Config.p('_lineheight')+2
									)

		self.comp.new_layer('shade', rect[0], rect[1]+Config.p('_lineheight')-1,
									rect[2], rect[3]-Config.p('_lineheight')+2
									)#.set_blit_flags(pygame.BLEND_RGBA_MULT)

		print 'Starting...'
		Compositor.RenderThread( self.comp ).start()
		print 'From start returned'
		Config.p('_compositor', self.comp)

##		Config.p('_status',  Informer.PfmInformer( ) )


	def MainLoop(self):

##		if False :
##			def lpm():
##				lpm.lp-=1
##				if lpm.lp>0: return str(lpm.lp)+" %"
##				return None
##			lpm.lp=100
##			mnu = Menu.PfmLongtime(Config.p('_compositor').get_layer('dialog'), lpm )
##			mnu.loop()

##		if True:
##			mnu = ModeKeytest.PfmKeytest( im )
##			mnu.loop()

		Net = ModLoad('core','Net')

		if False :
			Menu.Dialog(
##			('Net OK! ' if Net.is_net_available() else 'No net ')+
			'-=PythonedFileManager=- (ver='+VersionUpdate.ver()+') '+
			'This is preview version. Track for a real thing at WIZ.RUSBASE.NET',
			(
				{ 'type':'menu', 'text':'OK' },
			)
			)

		Mode = ModLoad('modes','Mode')

		while True:
			Mode.ActivateMode('ModeFM')

			while len(Mode.getActiveModes() )!=0:
				Mode.Clock.tick(5)

			#
			# forced exit was caled
			#
			if hasattr( Mode.exit, 'code'):
				return


			ch = Menu.Dialog(
				'Exit program?',
				(
					{ 'type':'menu', 'text':'Exit', 'val':True },
					{ 'type':'menu', 'text':'Stay', 'val':False },
				)
				)
			if ch['val']:
				return





# ----------------------------------------------------------------- #

def ModLoad( mtype, mname, basedir=os.path.realpath(os.path.curdir) ):
	if not hasattr( ModLoad, 'cache' ):
		ModLoad.cache = {}

	if ModLoad.cache.has_key( (mtype,mname) ):
		print "ModLoad cache",  mtype, mname
		res = ModLoad.cache[ (mtype,mname) ]
	else:
		print "ModLoad ", basedir, mtype, mname
		md = imp.find_module( mname, [ os.path.join( basedir,mtype) ] )
		res = imp.load_module( mname, *md )
		ModLoad.cache[ (mtype,mname) ] = res

	return res

# ----------------------------------------------------------------- #

if __name__ == "__main__":
	if not pygame.font: print 'Warning, fonts disabled'
	if not pygame.mixer: print 'Warning, sound disabled'

	pygame.init()

	Config			= ModLoad("core", "Config")
	Compositor		= ModLoad("core", "Compositor")
	Menu			= ModLoad("core", "Menu")
	Keymaps			= ModLoad("core", "Keymaps")
	#Log			= ModLoad("core", "Log")
	InputAbst		= ModLoad("core", "InputAbst")
	VersionUpdate	= ModLoad("core", "VersionUpdate")

	PfmMain().MainLoop()

# ----------------------------------------------------------------- #
