""" Core file menu """

import os, shutil

from pfm import ModLoad

Mode =  ModLoad("modes", "Mode")
Menu =  ModLoad("core", "Menu")
Informer =  ModLoad("core", "Informer")

PluginType = 'filetype'

class Plugin:
	name = "Core file"
	def isKnown( self,  entry ):
		if not entry['type'] == 'dirent':
			return False

		return True

##	def open( self, fm, entry ):
##		""" call related ViewMode """
##		pass
		
	def rename ( self, fm, item ):
		fm.inf.mode(Informer.MODE_NONE)
		Informer.set_text('Rename')
		text = Mode.ModalMode('ModeTextEd', os.path.basename(item['fullpath']))
		if text != None:
			if item['ftype']=='dir':
				text = text.strip('/') + '/'
			def _rename(fm=fm, item=item, text=text):
				try:
					nn = os.path.join( fm.dirnav.dir, text)
					os.rename( item['fullpath'], nn )
				except Exception, e:
					Menu.Infobox( 'Renaming error ' + str(e) )

			Menu.Wait(_rename, "rename")
			fm.dirnav.chdir( fm.dirnav.dir )
			fm.ts.relist( fm.dirnav.get_list(), text )
			fm.render()
		
	def rm( self, fm, item ):
		if item['ftype']=='dir':
			name = 'directory'
		else:
			name = 'file'
			
		ev = Menu.Dialog(
			'Delete '+name+'?',
			[
				{ 'type':'menu', 'text':'Delete', 'val':True },
				{ 'type':'menu', 'text':'Keep it!', 'val':False },
			]
		)		
		if not ev['val'] : return
		
##			def _del(dir=fm.dirnav, item=item, ts=ts):
		def _del( fm=fm, item=item ):
			try:
				if item['ftype']=='dir':
					shutil.rmtree( item['fullpath'] )
				else:
					os.unlink( item['fullpath'] )
				fm.ts.next()
				near = fm.ts.item()
				fm.dirnav.chdir( fm.dirnav.dir )
				if near:
					fm.ts.relist( fm.dirnav.get_list() , near['text'])
				else:
					fm.ts.relist( fm.dirnav.get_list() )
			except Exception, e:
				Menu.Infobox( 'Delete error ' + str(e) )
				fm.dirnav.chdir( fm.dirnav.dir )
				fm.ts.relist( fm.dirnav.get_list(), item['text'] )
		Menu.Wait(_del, "delete")
		fm.render()
	
			
##	def quickView( self,  entry ):
##		""" update related quickview """
##		pass

	def menuItems( self,  entry ):
		""" addinional menu actions """
		
		filemenu = [
			{ 'type':'menu', 'text':'Rename',  'call':self.rename },
			{ 'type':'menu', 'text':'Delete',  'call':self.rm },
		]
		
		return filemenu

