import os
from pfm import ModLoad, _threading

Log			= ModLoad("core", "Log")

PluginType = 'filetype'

class Plugin:
	name = "Directory"
	def isKnown( self, entry ):
		if not entry['type'] == 'dirent':
			return False
		if entry['ftype'] == 'dir':
			return True
		return False

	def open( self, fm, item ):
		""" call related ViewMode """
		fm.dirnav.chdir( item['fullpath'] )
		fm.ts.relist( fm.dirnav.get_list() )
		if fm.ts.item() :
			fm.inf.set_entry(fm.ts.item())

	def quickView( self,  entry, target ):
		""" update related quickview """	
		pw = PreviewUpdater( entry['fullpath'].encode('utf-8'), target )
		pw.start()
		return pw
					
	def menuItems( self,  entry ):
		""" addinional menu actions """
		return []

class PreviewUpdater(_threading.Thread):
	""" Async preview maker """
	def __init__(self, path, target):
		self.path = path
		self.tg = target
		_threading.Thread.__init__(self)

	def stop(self):
		""" do not need this preview any more"""
		pass

	def render(self):
		self.tg._text = [ 'Directory', 'items: '+str( self.count ) ]
		self.tg.render_texts( )		
		self.tg.render()


	def run(self):
		self.count = len(os.listdir( self.path ))
		self.render()
		