from pfm import ModLoad, _threading

Log			= ModLoad("core", "Log")
ImageMaster	= ModLoad("core", "ImageMaster")

Mode 		= ModLoad("modes", "Mode")


PluginType = 'filetype'

class Plugin:
	name = "Image file"
	def isKnown( self,  entry ):
		if not entry['type'] == 'dirent':
			return False
		if not entry['ftype'] == 'file':
			return False

		return ImageMaster.is_known_type(entry['fullpath'])

	def open( self, fm, item ):
		while self.isKnown(item):
			nextact = Mode.ModalMode( 'ModeImageView', item )
			Log.msg('nextact = ',nextact)
			if nextact == 'DOWN':
				fm.ts.next()
				if fm.ts.item() :
					fm.inf.set_entry( fm.ts.item() )
					item = fm.ts.item()
				#fm.render()
			elif nextact == 'UP':
				fm.ts.prev()
				if fm.ts.item() :
					fm.inf.set_entry( fm.ts.item() )
					item = fm.ts.item()
				#fm.render()
			else:
				break

	def quickView( self, entry, target ):
		""" update related quickview """
		#
		# update pw
		#
		w, h = target.pw_maxarea()
		_prevpw = QVPreviewUpdater_img(entry, w, h, target)
		_prevpw.start()
		return _prevpw

	def menuItems( self,  entry ):
		""" addinional menu actions """
		return []

class QVPreviewUpdater_img(_threading.Thread):
	""" Async preview maker """
	def __init__(self, entry, w, h, target):
		self._entry = entry
		self._w = w # _layer.get_width()/3
		self._h = h
		self.tg = target
		self.ok = True
		self.pw = None
		self.sf = None
		self.sf_y = None
		self.label = "preview"
		_threading.Thread.__init__(self)

	def stop(self):
		""" do not need this preview any more"""
		print "pw stopped!"
		self.ok = False
##	def renderplace(self, surf, y):
##		self.sf_y = y
##		self.sf   = surf
##		if self.pw: self.render

	def render(self):
		print "pw - final!"
		if(self.label):	self.tg.render_texts( self.label )
		if(self.pw):	self.tg.append_image( self.pw )
		self.tg.render()


	def run(self):
		Log.msg("PWM", self._entry['fullpath'])
		if not self.ok: return

		self.label	= None
		self.pw		= None

		(ow, oh)   = ImageMaster.get_imagesize( self._entry['fullpath'].encode('utf-8') )
##		print "long lock..."
##		pygame.time.wait(1000)
##		print "...long lock"
		if not self.ok: return

		if ow > 1600 or oh > 1600:
			pw = None
			self.label = 'big image '+str( ow )+'x'+str( oh )
		else:
			pwidth  = self._w
			pheight = oh * pwidth / ow
			if pheight>self._h:
				pheight = self._h
				pwidth  = ow * pheight / oh
			pw = ImageMaster.get_preview(self._entry['fullpath'].encode('utf-8'), ( pwidth, pheight ) )
			self.label = 'image '+str( ow )+'x'+str( oh )

		if not self.ok: return
		self.pw = pw
		self.render()

	